Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 3550)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 3551)
@@ -4004,34 +4048,34 @@
 
                 diss_r(k) = - ABS( u_comp(k) - gu ) * (                      &
-                          ( 10.0_wp * ibit11 * adv_mom_5                        &
-                       +     3.0_wp * ibit10 * adv_mom_3                        & 
-                       +              ibit9  * adv_mom_1                        &
+                          ( 10.0_wp * ibit11 * adv_mom_5                     &
+                       +     3.0_wp * ibit10 * adv_mom_3                     & 
+                       +              ibit9  * adv_mom_1                     &
                           ) *                                                &
                                  ( u(k,j,i+1) - u(k,j,i)  )                  &
-                   -      (  5.0_wp * ibit11 * adv_mom_5                        &
-                       +              ibit10 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit11 * adv_mom_5                     &
+                       +              ibit10 * adv_mom_3                     &
                           ) *                                                &
                                  ( u(k,j,i+2) - u(k,j,i-1) )                 &
-                   +      (           ibit11 * adv_mom_5                        &
+                   +      (           ibit11 * adv_mom_5                     &
                           ) *                                                &
                                  ( u(k,j,i+3) - u(k,j,i-2) )                 &
                                                      )
 
-                ibit14 = IBITS(advc_flags_1(k,j,i),14,1)
-                ibit13 = IBITS(advc_flags_1(k,j,i),13,1)
-                ibit12 = IBITS(advc_flags_1(k,j,i),12,1)
+                ibit14 = REAL( IBITS(advc_flags_1(k,j,i),14,1), KIND = wp )
+                ibit13 = REAL( IBITS(advc_flags_1(k,j,i),13,1), KIND = wp )
+                ibit12 = REAL( IBITS(advc_flags_1(k,j,i),12,1), KIND = wp )
 
                 v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
                 flux_n(k) = v_comp * (                                       &
-                          ( 37.0_wp * ibit14 * adv_mom_5                        &
-                       +     7.0_wp * ibit13 * adv_mom_3                        &
-                       +              ibit12 * adv_mom_1                        &
+                          ( 37.0_wp * ibit14 * adv_mom_5                     &
+                       +     7.0_wp * ibit13 * adv_mom_3                     &
+                       +              ibit12 * adv_mom_1                     &
                           ) *                                                &
                                  ( u(k,j+1,i) + u(k,j,i)   )                 &
-                   -      (  8.0_wp * ibit14 * adv_mom_5                        &
-                       +              ibit13 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit14 * adv_mom_5                     &
+                       +              ibit13 * adv_mom_3                     &
                           ) *                                                &
                                  ( u(k,j+2,i) + u(k,j-1,i) )                 &
-                   +      (           ibit14 * adv_mom_5                        & 
+                   +      (           ibit14 * adv_mom_5                     & 
                           ) *                                                &
                                  ( u(k,j+3,i) + u(k,j-2,i) )                 &
@@ -4039,14 +4083,14 @@
 
                 diss_n(k) = - ABS ( v_comp ) * (                             &
-                          ( 10.0_wp * ibit14 * adv_mom_5                        &
-                       +     3.0_wp * ibit13 * adv_mom_3                        &
-                       +              ibit12 * adv_mom_1                        &
+                          ( 10.0_wp * ibit14 * adv_mom_5                     &
+                       +     3.0_wp * ibit13 * adv_mom_3                     &
+                       +              ibit12 * adv_mom_1                     &
                           ) *                                                &
                                  ( u(k,j+1,i) - u(k,j,i)  )                  &
-                   -      (  5.0_wp * ibit14 * adv_mom_5                        &
-                       +              ibit13 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit14 * adv_mom_5                     &
+                       +              ibit13 * adv_mom_3                     &
                           ) *                                                &
                                  ( u(k,j+2,i) - u(k,j-1,i) )                 &
-                   +      (           ibit14 * adv_mom_5                        &
+                   +      (           ibit14 * adv_mom_5                     &
                           ) *                                                &
                                  ( u(k,j+3,i) - u(k,j-2,i) )                 &
@@ -4055,7 +4099,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
-                ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
-                ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
+                ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
+                ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
+                ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit17
@@ -4065,14 +4109,14 @@
                 w_comp    = w(k,j,i) + w(k,j,i-1)
                 flux_t(k) = w_comp * rho_air_zw(k) * (                       &
-                          ( 37.0_wp * ibit17 * adv_mom_5                        &
-                       +     7.0_wp * ibit16 * adv_mom_3                        &
-                       +              ibit15 * adv_mom_1                        & 
+                          ( 37.0_wp * ibit17 * adv_mom_5                     &
+                       +     7.0_wp * ibit16 * adv_mom_3                     &
+                       +              ibit15 * adv_mom_1                     & 
                           ) *                                                &
                              ( u(k+1,j,i)  + u(k,j,i)     )                  &
-                   -      (  8.0_wp * ibit17 * adv_mom_5                        &
-                       +              ibit16 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit17 * adv_mom_5                     &
+                       +              ibit16 * adv_mom_3                     &
                           ) *                                                &
                              ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
-                   +      (           ibit17 * adv_mom_5                        &
+                   +      (           ibit17 * adv_mom_5                     &
                           ) *                                                &
                              ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
@@ -4080,14 +4124,14 @@
 
                 diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
-                          ( 10.0_wp * ibit17 * adv_mom_5                        &
-                       +     3.0_wp * ibit16 * adv_mom_3                        &
-                       +              ibit15 * adv_mom_1                        &
+                          ( 10.0_wp * ibit17 * adv_mom_5                     &
+                       +     3.0_wp * ibit16 * adv_mom_3                     &
+                       +              ibit15 * adv_mom_1                     &
                           ) *                                                &
                              ( u(k+1,j,i)   - u(k,j,i)    )                  &
-                   -      (  5.0_wp * ibit17 * adv_mom_5                        &
-                       +              ibit16 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit17 * adv_mom_5                     &
+                       +              ibit16 * adv_mom_3                     &
                           ) *                                                &
                              ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
-                   +      (           ibit17 * adv_mom_5                        &
+                   +      (           ibit17 * adv_mom_5                     &
                            ) *                                               &
                              ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
@@ -4099,21 +4143,24 @@
                 div = ( ( u_comp(k) * ( ibit9 + ibit10 + ibit11 )             &
                 - ( u(k,j,i)   + u(k,j,i-1)   )                               &
-                                    * ( IBITS(advc_flags_1(k,j,i-1),9,1)      &
-                                      + IBITS(advc_flags_1(k,j,i-1),10,1)     &
-                                      + IBITS(advc_flags_1(k,j,i-1),11,1)     &
+                                    * (                                       &
+                    REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )      &
+                  + REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )      &
+                  + REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )      &
                                       )                                       &
                   ) * ddx                                                     &
                +  ( ( v_comp + gv ) * ( ibit12 + ibit13 + ibit14 )            &
                   - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
-                                    * ( IBITS(advc_flags_1(k,j-1,i),12,1)     &
-                                      + IBITS(advc_flags_1(k,j-1,i),13,1)     &
-                                      + IBITS(advc_flags_1(k,j-1,i),14,1)     &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )     &
                                       )                                       &
                   ) * ddy                                                     &
                +  ( w_comp * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )     &
                 - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)             &
-                                    * ( IBITS(advc_flags_1(k-1,j,i),15,1)     &
-                                      + IBITS(advc_flags_1(k-1,j,i),16,1)     &
-                                      + IBITS(advc_flags_1(k-1,j,i),17,1)     &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k-1,j,i),15,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k-1,j,i),16,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k-1,j,i),17,1), KIND = wp )     &
                                       )                                       &  
                   ) * drho_air(k) * ddzw(k)                                   &
@@ -4186,7 +4233,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
-                ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
-                ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
+                ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
+                ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
+                ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit17
@@ -4309,13 +4356,4 @@
 
        INTEGER(iwp) ::  i      !< grid index along x-direction
-       INTEGER(iwp) ::  ibit18 !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp) ::  ibit19 !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp) ::  ibit20 !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp) ::  ibit21 !< flag indicating 1st-order scheme along y-direction
-       INTEGER(iwp) ::  ibit22 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp) ::  ibit23 !< flag indicating 5th-order scheme along y-direction
-       INTEGER(iwp) ::  ibit24 !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp) ::  ibit25 !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp) ::  ibit26 !< flag indicating 5th-order scheme along z-direction
        INTEGER(iwp) ::  j      !< grid index along y-direction
        INTEGER(iwp) ::  k      !< grid index along z-direction
@@ -4325,4 +4363,13 @@
        INTEGER(iwp) ::  tn = 0 !< number of OpenMP thread
        
+       REAL(wp)    ::  ibit18 !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit19 !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit20 !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit21 !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit22 !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit23 !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit24 !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit25 !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit26 !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div    !< diverence on v-grid
@@ -4355,7 +4402,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit20 = IBITS(advc_flags_1(k,j,i-1),20,1)
-             ibit19 = IBITS(advc_flags_1(k,j,i-1),19,1)
-             ibit18 = IBITS(advc_flags_1(k,j,i-1),18,1)
+             ibit20 = REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )
+             ibit19 = REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )
+             ibit18 = REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )
 
              u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
@@ -4413,7 +4460,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit23 = IBITS(advc_flags_1(k,j-1,i),23,1)
-             ibit22 = IBITS(advc_flags_1(k,j-1,i),22,1)
-             ibit21 = IBITS(advc_flags_1(k,j-1,i),21,1)
+             ibit23 = REAL( IBITS(advc_flags_1(k,j-1,i),23,1), KIND = wp )
+             ibit22 = REAL( IBITS(advc_flags_1(k,j-1,i),22,1), KIND = wp )
+             ibit21 = REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )
 
              v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
@@ -4473,7 +4520,7 @@
              DO  k = nzb+1, nzb_max
 
-                ibit20 = IBITS(advc_flags_1(k,j,i),20,1)
-                ibit19 = IBITS(advc_flags_1(k,j,i),19,1)
-                ibit18 = IBITS(advc_flags_1(k,j,i),18,1)
+                ibit20 = REAL( IBITS(advc_flags_1(k,j,i),20,1), KIND = wp )
+                ibit19 = REAL( IBITS(advc_flags_1(k,j,i),19,1), KIND = wp )
+                ibit18 = REAL( IBITS(advc_flags_1(k,j,i),18,1), KIND = wp )
 
                 u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
@@ -4508,7 +4555,7 @@
                                               )
 
-                ibit23 = IBITS(advc_flags_1(k,j,i),23,1)
-                ibit22 = IBITS(advc_flags_1(k,j,i),22,1)
-                ibit21 = IBITS(advc_flags_1(k,j,i),21,1)
+                ibit23 = REAL( IBITS(advc_flags_1(k,j,i),23,1), KIND = wp )
+                ibit22 = REAL( IBITS(advc_flags_1(k,j,i),22,1), KIND = wp )
+                ibit21 = REAL( IBITS(advc_flags_1(k,j,i),21,1), KIND = wp )
 
                 v_comp(k) = v(k,j+1,i) + v(k,j,i)
@@ -4545,7 +4592,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
-                ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
-                ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
+                ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
+                ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
+                ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit26
@@ -4590,7 +4637,8 @@
                                        * ( ibit18 + ibit19 + ibit20 )         &
                 - ( u(k,j-1,i)   + u(k,j,i) )                                 &
-                                       * ( IBITS(advc_flags_1(k,j,i-1),18,1)  &
-                                         + IBITS(advc_flags_1(k,j,i-1),19,1)  &
-                                         + IBITS(advc_flags_1(k,j,i-1),20,1)  &
+                                       * (                                    &
+                        REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )  &
                                          )                                    &
                   ) * ddx                                                     &
@@ -4598,7 +4646,8 @@
                                        * ( ibit21 + ibit22 + ibit23 )         &
                 - ( v(k,j,i)     + v(k,j-1,i) )                               &
-                                       * ( IBITS(advc_flags_1(k,j-1,i),21,1)  &
-                                         + IBITS(advc_flags_1(k,j-1,i),22,1)  &
-                                         + IBITS(advc_flags_1(k,j-1,i),23,1)  &
+                                       * (                                    &
+                        REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),22,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),23,1), KIND = wp )  &
                                          )                                    &
                   ) * ddy                                                     &
@@ -4606,7 +4655,8 @@
                                        * ( ibit24 + ibit25 + ibit26 )         &
                 - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)             &
-                                       * ( IBITS(advc_flags_1(k-1,j,i),24,1)  &
-                                         + IBITS(advc_flags_1(k-1,j,i),25,1)  &
-                                         + IBITS(advc_flags_1(k-1,j,i),26,1)  &
+                                       * (                                    &
+                        REAL( IBITS(advc_flags_1(k-1,j,i),24,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),25,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),26,1), KIND = wp )  &
                                          )                                    &
                    ) * drho_air(k) * ddzw(k)                                  &
@@ -4684,7 +4734,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
-                ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
-                ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
+                ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
+                ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
+                ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit26
@@ -4811,13 +4861,4 @@
 
        INTEGER(iwp) ::  i      !< grid index along x-direction
-       INTEGER(iwp) ::  ibit27 !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp) ::  ibit28 !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp) ::  ibit29 !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp) ::  ibit30 !< flag indicating 1st-order scheme along y-direction
-       INTEGER(iwp) ::  ibit31 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp) ::  ibit32 !< flag indicating 5th-order scheme along y-direction
-       INTEGER(iwp) ::  ibit33 !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp) ::  ibit34 !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp) ::  ibit35 !< flag indicating 5th-order scheme along z-direction
        INTEGER(iwp) ::  j      !< grid index along y-direction
        INTEGER(iwp) ::  k      !< grid index along z-direction
@@ -4827,4 +4868,13 @@
        INTEGER(iwp) ::  tn = 0 !< number of OpenMP thread
        
+       REAL(wp)    ::  ibit27 !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit28 !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit29 !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit30 !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit31 !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit32 !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit33 !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit34 !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit35 !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div    !< divergence on w-grid
@@ -4857,7 +4907,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit29 = IBITS(advc_flags_1(k,j,i-1),29,1)
-             ibit28 = IBITS(advc_flags_1(k,j,i-1),28,1)
-             ibit27 = IBITS(advc_flags_1(k,j,i-1),27,1)
+             ibit29 = REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )
+             ibit28 = REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )
+             ibit27 = REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )
 
              u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
@@ -4915,7 +4965,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit32 = IBITS(advc_flags_2(k,j-1,i),0,1)
-             ibit31 = IBITS(advc_flags_1(k,j-1,i),31,1)
-             ibit30 = IBITS(advc_flags_1(k,j-1,i),30,1)
+             ibit32 = REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )
+             ibit31 = REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )
+             ibit30 = REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )
 
              v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
@@ -4981,7 +5031,7 @@
              DO  k = nzb+1, nzb_max
 
-                ibit29 = IBITS(advc_flags_1(k,j,i),29,1)
-                ibit28 = IBITS(advc_flags_1(k,j,i),28,1)
-                ibit27 = IBITS(advc_flags_1(k,j,i),27,1)
+                ibit29 = REAL( IBITS(advc_flags_1(k,j,i),29,1), KIND = wp )
+                ibit28 = REAL( IBITS(advc_flags_1(k,j,i),28,1), KIND = wp )
+                ibit27 = REAL( IBITS(advc_flags_1(k,j,i),27,1), KIND = wp )
 
                 u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
@@ -5016,7 +5066,7 @@
                                               )
 
-                ibit32 = IBITS(advc_flags_2(k,j,i),0,1)
-                ibit31 = IBITS(advc_flags_1(k,j,i),31,1)
-                ibit30 = IBITS(advc_flags_1(k,j,i),30,1)
+                ibit32 = REAL( IBITS(advc_flags_2(k,j,i),0,1),  KIND = wp )
+                ibit31 = REAL( IBITS(advc_flags_1(k,j,i),31,1), KIND = wp )
+                ibit30 = REAL( IBITS(advc_flags_1(k,j,i),30,1), KIND = wp )
 
                 v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
@@ -5053,7 +5103,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
-                ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
-                ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
+                ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
+                ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
+                ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit35
@@ -5097,21 +5147,24 @@
                 div = ( ( ( u_comp + gu ) * ( ibit27 + ibit28 + ibit29 )      &
                   - ( u(k+1,j,i) + u(k,j,i)   )                               & 
-                                    * ( IBITS(advc_flags_1(k,j,i-1),27,1)     &
-                                      + IBITS(advc_flags_1(k,j,i-1),28,1)     &
-                                      + IBITS(advc_flags_1(k,j,i-1),29,1)     &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )     &
                                       )                                       &
                   ) * ddx                                                     &
               +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            &
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
-                                    * ( IBITS(advc_flags_1(k,j-1,i),30,1)     &
-                                      + IBITS(advc_flags_1(k,j-1,i),31,1)     &
-                                      + IBITS(advc_flags_2(k,j-1,i),0,1)      &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )     &
                                       )                                       &
                   ) * ddy                                                     &
               +   ( w_comp * rho_air(k+1) * ( ibit33 + ibit34 + ibit35 )      &
                 - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
-                                    * ( IBITS(advc_flags_2(k-1,j,i),1,1)      &
-                                      + IBITS(advc_flags_2(k-1,j,i),2,1)      &
-                                      + IBITS(advc_flags_2(k-1,j,i),3,1)      &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_2(k-1,j,i),1,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_2(k-1,j,i),2,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_2(k-1,j,i),3,1), KIND = wp )      &
                                       )                                       & 
                   ) * drho_air_zw(k) * ddzu(k+1)                              &
@@ -5176,7 +5229,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
-                ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
-                ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
+                ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
+                ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
+                ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit35
